# 30jul23 Software Lab. Alexander Burger

,"Step Counter"

(symbols '(android pico))

(local) (TYPE_STEP_COUNTER SENSOR_DELAY_NORMAL getDefaultSensor onSensorChanged
values registerListener unregisterListener startTone)

(de TYPE_STEP_COUNTER . 19)  # Sensor
(de SENSOR_DELAY_NORMAL . 3)  # SensorManager


(symbols 'pico~steps 'android 'pico)

(local) (*Daily *Man *Beep *Lsn *Count *Base *Date *Today *Start *Sse *Lap *Lap2
display save)

(permit "android.permission.ACTIVITY_RECOGNITION")

(once
   (setq
      *Count (or (rc "steps.rc" 'old) 0)
      *Base (or (rc "steps.rc" 'base) *Count)
      *Start (or (rc "steps.rc" 'start) *Count)
      *Date (or (rc "steps.rc" 'date) (date))
      *Today (or (rc "steps.rc" 'today) *Date)
      *Daily (or (rc "steps.rc" 'daily) 10000)
      *Man (java CONTEXT 'getSystemService "sensor")  # SensorManager
      *Lsn (java T "android.hardware.SensorEventListener") )
   (java *Man 'registerListener *Lsn
      (java *Man 'getDefaultSensor TYPE_STEP_COUNTER)  # Sensor
      SENSOR_DELAY_NORMAL )
   (finish (java *Man 'unregisterListener *Lsn))
   (def 'onSensorChanged *Lsn
      '((Evt)
         (with (wipe Evt)
            (let C *Count
               (setq *Count (*/ (: values 1) 1000000))
               (when (gt0 (- C *Count))
                  (dec '*Base @)
                  (dec '*Start @) ) )
            (and *Beep (java @ 'startTone 24))  # ToneGenerator.TONE_PROP_BEEP = 24
            (serverSend *Sse
               (display) ) ) ) ) )

(de display ()
   (let Dat (date)
      (unless (== Dat *Today)
         (setq *Today Dat  *Start *Count) )
      (prin
         (- *Count *Base (* *Daily (- Dat *Date)))
         "<br/>"
         (- *Count *Start)
         "<br/>"
         (- *Count *Lap)
         "<br/>"
         (- *Count *Lap2) ) ) )

(de save ()
   (when *Base
      (rc "steps.rc"
         'base *Base
         'date *Date
         'today *Today
         'start *Start
         'old *Count ) ) )

(start
   (wake T) )

(stop
   (save)
   (wake NIL) )

(menu ,"Step Counter"
   (and *PRG (save))
   (<h1> "center blue" ,"Step Counter")
   (<div> '(id . "steps")
      (display) )
   (serverSentEvent "steps" '*Sse)
   (----)
   (form "adjust"
      (gui '(+NumField) 4)
      (--)
      (gui '(+Button) ,"Adjust"
         '(let F (field -1)
            (let N (val> F)
               (dec '*Base N)
               (dec '*Start N) )
            (clr> F) ) )
      (----)
      (gui '(+Button) ,"Reset"
         '(cond
            ((== *Lap *Count)
               (ask ,"Reset to zero?"
                  (setq *Start *Count  *Base *Count  *Date (date)) ) )
            ((== *Lap2 *Count)
               (setq *Lap *Count) )
            (T
               (default *Lap *Count)
               (setq *Lap2 *Count) ) ) ) ) )
